require "loguse/version"
require "loguse/configuration"
require "loguse/loguse_actor"
require "loguse/shell"

class Loguse 
	extend Configuration

	define_setting :url, "http://localhost/"
  	define_setting :url_encoded, false
  	define_setting :period, 30
  	define_setting :silent, true
  	define_setting :payload_proc, Proc.new{ {name: "Loguse", time: Time.now} } # Returns a hash of values which become the JSON payload to a POST

  	class Watchman < Celluloid::SupervisionGroup
  		supervise Loguse::LoguseActor, as: :loguse_actor
  	end

  	def self.run
  		Loguse::Watchman.run!
  	end
end

 Loguse.run
